#! /usr/bin/env node

const program = require('commander');
const download = require('download-git-repo');
const chalk = require('chalk');
const ora = require('ora');

const fs = require('fs');
const dir_path = require('path');

const exec = require('child_process').exec;

function copyFile(src_file, tar_file) {
    fs.writeFileSync(tar_file, fs.readFileSync(src_file));   //filename如果不存在，则会在路径上新建文件
}

function checkDirectory(src, dst, callback) {
    fs.access(dst, fs.constants.F_OK, (err) => {
        if (err) {
            fs.mkdirSync(dst);
            callback(src, dst);
        } else {
            callback(src, dst);
        }
    });
};

function copyDirectory(src, dst) {
    if (!fs.existsSync(dst)) {
        fs.mkdirSync(dst);
    }
    let paths = fs.readdirSync(src); //同步读取当前目录
    paths.forEach(function (path) {
        let _src = dir_path.join(src, path);
        let _dst = dir_path.join(dst, path);
        stats = fs.statSync(_src);
        if (stats.isFile()) { //如果是个文件则拷贝 
            copyFile(_src, _dst);
        } else if (stats.isDirectory()) { //是目录则 递归 
            checkDirectory(_src, _dst, copyDirectory);
        }
    });
}

program
    .version('0.1.6')
    .parse(process.argv);

const spinner = ora('donwloading tomjs-framework by github').start();
download('tomgjm/tom-framework', '.', function (err) {
    if (!err) {
        //进行一些文件初始化工作
        const dir = `${process.cwd()}/`;
        copyFile(dir + '.env.example', dir + '.env');
        fs.mkdirSync(dir + "logs");
        fs.mkdirSync(dir + "keys");
        copyDirectory(dir + 'keys.example', dir + 'keys');
        let data = fs.readFileSync(dir + 'package.json');
        let _data = JSON.parse(data.toString());
        _data.name = 'my_tomjs';
        _data.version = '1.0.0';
        let str = JSON.stringify(_data, null, 4);
        fs.writeFileSync(dir + 'package.json', str);
        // 可以输出一些项目成功的信息
        spinner.text = 'donwloading tomjs-framework';
        console.info(chalk.blueBright(' end.'));
        spinner.text = 'run command: npm i ';
        exec("npm i", function (error, stdout, stderr) {
            if (error) {
                console.info(chalk.blueBright(', error:'), error, stderr);
            } else {
                console.info(chalk.blueBright(', end:'), stdout);
            }
            process.exit(0);
        });

    } else {
        // 可以输出一些项目失败的信息
        console.error(err);
    }
})
